#include <stdio.h>
#include <string.h>
#include "game.h"
#include "gfx.h"
#include "copper.h"
#include "data.h"
#include "sprite.h"

#include "hwregs.h"	/* XXX */

#define TILE_W	64
#define TILE_H	32

void draw_tile(int tid, int x, int y, int light);

static uint16_t *sprdata[NUM_HWSPRITES];

/* hardcoded test sprite */
static struct sprite test_sprite;

int game_init(void)
{
	int i;

	printf("hello world\n");

	REG_COLOR0 = 0x221;
	REG_COLOR1 = 0x222;
	REG_COLOR2 = 0x332;
	REG_COLOR3 = 0x433;
	REG_COLOR4 = 0x543;
	REG_COLOR5 = 0x554;
	REG_COLOR6 = 0x654;
	REG_COLOR7 = 0x765;

	for(i=0; i<16; i++) {
		REG_COLOR_PTR[i + 16] = sprpal[i];
	}

	sprdata[0] = spr0a;
	sprdata[1] = spr0b;
	sprdata[2] = spr1a;
	sprdata[3] = spr1b;
	sprdata[4] = spr2a;
	sprdata[5] = spr2b;

	test_sprite.width = test_sprite.height = 48;
	test_sprite.origx = 24;
	test_sprite.origy = 24;
	test_sprite.img = test_sprite.mask = 0;
	test_sprite.hwslices = 3;
	for(i=0; i<8; i++) {
		test_sprite.hwspr[i] = i < 6 ? sprdata[i] : 0;
	}

	return 0;
}

#define XTILES	5
#define YTILES	13

void game_draw(void)
{
	int i, j, xoffs, yoffs, ntiles;

	yoffs = 0;
	for(i=0; i<YTILES; i++) {
		xoffs = i & 1 ? TILE_W / 2 : 0;
		ntiles = i & 1 ? XTILES - 1 : XTILES;
		for(j=0; j<ntiles; j++) {
			draw_tile(0, xoffs, yoffs, 0);
			xoffs += TILE_W;
		}
		yoffs += TILE_H / 2;
	}

	begin_sprites();
	draw_sprite(&test_sprite, 160, 100);
	end_sprites();
}


void draw_tile(int tid, int x, int y, int light)
{
	unsigned char *dest = bplptr[0] + (y * SCANSZ * NBPL) + x / 8;
	unsigned char *src = test_tile;

	wait_blit();

	REG32_BLTCON = BLTCON_USEA | BLTCON_USEB | BLTCON_USEC | BLTCON_USED |
		BLTCON_LF(0xca);
	REG32_BLTAFLWM = 0xffffffff;
	REG_BLTAMOD = 0;
	REG_BLTBMOD = 0;
	REG_BLTCMOD = SCANSZ - TILE_W / 8;
	REG_BLTDMOD = SCANSZ - TILE_W / 8;
	REG32_BLTAPT = (intptr_t)test_tile_mask;
	REG32_BLTBPT = (intptr_t)src;
	REG32_BLTCPT = (intptr_t)dest;
	REG32_BLTDPT = (intptr_t)dest;
	REG_BLTSIZE = BLTSIZE(TILE_W, TILE_H * NBPL);
}
